> ## Documentation Index
> Fetch the complete documentation index at: https://docs.omneo.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Edit Product

> A `PUT` to the `/products/{productId}` endpoint allows your application to edit a Product record.



## OpenAPI

````yaml put /v3/products/{product}
openapi: 3.1.0
info:
  title: Omneo
  version: 0.0.1
servers:
  - url: https://api.{tenant}.getomneo.com/api
    variables:
      tenant:
        default: example
security: []
paths:
  /v3/products/{product}:
    put:
      tags:
        - Product
      summary: Edit Product
      description: >-
        A `PUT` to the `/products/{productId}` endpoint allows your application
        to edit a Product record.
      operationId: products.update
      parameters:
        - name: product
          in: path
          required: true
          description: The product ID
          schema:
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateProduct'
      responses:
        '200':
          description: '`Product`'
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/Product'
                required:
                  - data
        '401':
          $ref: '#/components/responses/AuthenticationException'
        '403':
          $ref: '#/components/responses/AuthorizationException'
        '404':
          $ref: '#/components/responses/ModelNotFoundException'
        '422':
          $ref: '#/components/responses/ValidationException'
components:
  schemas:
    UpdateProduct:
      type: object
      properties:
        title:
          type: string
        external_id:
          type:
            - string
            - 'null'
        status:
          type: string
          enum:
            - new
            - active
            - rundown
            - discontinued
            - ranged
            - deleted
            - archived
            - draft
        brand:
          type: string
        type:
          type:
            - string
            - 'null'
          enum:
            - appointment
            - simple
            - configurable
            - downloadable
            - gift
            - bundle
            - voucher
            - service
            - subscription
        description:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        position:
          type: integer
        department:
          type:
            - string
            - 'null'
        web_url:
          type:
            - string
            - 'null'
        archive_existing_variants:
          type:
            - boolean
            - 'null'
        meta:
          type:
            - array
            - 'null'
          items:
            type: string
        organisation_id:
          type:
            - integer
            - 'null'
        systems:
          type: array
          items:
            type: string
        channels:
          type: array
          items:
            type: string
        tags:
          type: array
          items:
            type: string
        images:
          type: array
          items:
            type: object
            properties:
              url:
                type: string
              sort_order:
                type:
                  - integer
                  - 'null'
            required:
              - url
        variants:
          type: array
          items:
            type: object
            properties:
              id:
                type:
                  - integer
                  - 'null'
              title:
                type:
                  - string
                  - 'null'
              sku:
                type: string
              description:
                type:
                  - string
                  - 'null'
              available_quantity:
                type:
                  - integer
                  - 'null'
              price:
                type: number
              images:
                type: array
                items:
                  type: object
                  properties:
                    url:
                      type: string
                    sort_order:
                      type:
                        - integer
                        - 'null'
                  required:
                    - url
              price_discounted:
                type:
                  - number
                  - 'null'
              price_comparison:
                type:
                  - number
                  - 'null'
              price_cost:
                type:
                  - number
                  - 'null'
              position:
                type: integer
              tags:
                type: array
                items:
                  type: string
                minItems: 1
              options:
                type: array
                items:
                  type: object
                  properties:
                    name:
                      type: string
                    value:
                      type: string
                    sort_order:
                      type:
                        - integer
                        - 'null'
                  required:
                    - name
                    - value
                minItems: 1
              meta:
                type:
                  - array
                  - 'null'
                items:
                  type: string
        custom_fields:
          type: array
          items:
            type: object
            properties:
              namespace:
                type: string
              handle:
                type: string
              type:
                type: string
                enum:
                  - string
                  - integer
                  - float
                  - boolean
                  - json
                  - array
              value:
                type: string
            required:
              - namespace
              - handle
              - type
              - value
      title: UpdateProduct
    Product:
      type: object
      properties:
        id:
          type: integer
        title:
          type: string
        handle:
          type: string
        type:
          type:
            - string
            - 'null'
        external_id:
          type:
            - string
            - 'null'
        status:
          type:
            - string
            - 'null'
        brand:
          type:
            - string
            - 'null'
        department:
          type:
            - string
            - 'null'
        link_brand:
          type:
            - string
            - 'null'
        link_department:
          type: string
        web_url:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        position:
          type: integer
        images:
          type: string
        systems:
          type: array
          items:
            $ref: '#/components/schemas/System'
        channels:
          type: array
          items:
            $ref: '#/components/schemas/System'
        tags:
          type: array
          items:
            $ref: '#/components/schemas/Tag'
        options:
          type: string
        custom_fields:
          type: array
          items:
            $ref: '#/components/schemas/CustomField'
        variants:
          type: array
          items:
            $ref: '#/components/schemas/ProductVariant'
        organisation:
          anyOf:
            - $ref: '#/components/schemas/Organisation'
            - type: 'null'
        meta:
          type:
            - array
            - 'null'
          items: {}
        created_at:
          type: string
        updated_at:
          type: string
      required:
        - id
        - title
        - handle
        - type
        - external_id
        - status
        - brand
        - department
        - link_brand
        - link_department
        - web_url
        - description
        - currency
        - position
        - images
        - systems
        - channels
        - tags
        - options
        - custom_fields
        - variants
        - organisation
        - meta
        - created_at
        - updated_at
      title: Product
    System:
      type: string
      title: System
    Tag:
      type: string
      title: Tag
    CustomField:
      type: object
      properties:
        name:
          type:
            - string
            - 'null'
        handle:
          type: string
        namespace:
          type: string
        value:
          type: string
        type:
          type: string
        custom_fieldable_type:
          type: string
        custom_fieldable:
          anyOf:
            - type: 'null'
            - $ref: '#/components/schemas/TransactionBasic'
            - type: object
              properties:
                id:
                  type: integer
                address_line_1:
                  type: string
                address_line_2:
                  type: string
                address_line_3:
                  type: string
                city:
                  type: string
                postcode:
                  type: string
                state:
                  type: string
                country:
                  type: string
                phone:
                  type: string
                external_id:
                  type: string
                iso:
                  type: string
                iso_state:
                  type: string
                profile_id:
                  type: string
              required:
                - id
                - address_line_1
                - address_line_2
                - address_line_3
                - city
                - postcode
                - state
                - country
                - phone
                - external_id
                - iso
                - iso_state
                - profile_id
        created_at:
          type: string
        updated_at:
          type: string
        is_index:
          type:
            - integer
            - 'null'
      required:
        - name
        - handle
        - namespace
        - value
        - type
        - custom_fieldable_type
        - custom_fieldable
        - created_at
        - updated_at
        - is_index
      title: CustomField
    ProductVariant:
      type: object
      properties:
        id:
          type: integer
        product_id:
          type: integer
        sku:
          type: string
        external_id:
          type:
            - string
            - 'null'
        barcode:
          type:
            - string
            - 'null'
        web_url:
          type:
            - string
            - 'null'
        handle:
          type:
            - string
            - 'null'
        title:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        position:
          type: integer
        price:
          type: number
        price_discounted:
          type:
            - number
            - 'null'
        price_comparison:
          type:
            - number
            - 'null'
        price_cost:
          type:
            - number
            - 'null'
        available_quantity:
          type:
            - integer
            - 'null'
        images:
          type: string
        meta:
          type:
            - array
            - 'null'
          items: {}
        tags:
          type: array
          items:
            $ref: '#/components/schemas/Tag'
        options:
          type: array
          items:
            $ref: '#/components/schemas/ProductOption'
        created_at:
          type: string
        updated_at:
          type: string
        deleted_at:
          type: string
      required:
        - id
        - product_id
        - sku
        - external_id
        - barcode
        - web_url
        - handle
        - title
        - description
        - position
        - price
        - price_discounted
        - price_comparison
        - price_cost
        - available_quantity
        - images
        - meta
        - tags
        - options
        - created_at
        - updated_at
        - deleted_at
      title: ProductVariant
    Organisation:
      type: object
      properties:
        id:
          type: integer
        name:
          type: string
        handle:
          type: string
        description:
          type:
            - string
            - 'null'
        short_description:
          type:
            - string
            - 'null'
        icon:
          type:
            - string
            - 'null'
        image_url:
          type:
            - string
            - 'null'
        notes:
          type:
            - string
            - 'null'
        type:
          type: string
        status:
          type:
            - string
            - 'null'
        is_tenant:
          type:
            - integer
            - 'null'
        is_active:
          type:
            - integer
            - 'null'
        phone:
          type:
            - string
            - 'null'
        email:
          type:
            - string
            - 'null'
        secondary_phone:
          type:
            - string
            - 'null'
        domain:
          type:
            - string
            - 'null'
        authorised_domains:
          type:
            - array
            - 'null'
          items: {}
        meta:
          type:
            - array
            - 'null'
          items: {}
        locations:
          type: array
          items:
            $ref: '#/components/schemas/Location'
        address:
          $ref: '#/components/schemas/Address'
        custom_fields:
          type: object
          additionalProperties: {}
        created_at:
          type: string
        updated_at:
          type: string
      required:
        - id
        - name
        - handle
        - description
        - short_description
        - icon
        - image_url
        - notes
        - type
        - status
        - is_tenant
        - is_active
        - phone
        - email
        - secondary_phone
        - domain
        - authorised_domains
        - meta
        - locations
        - address
        - custom_fields
        - created_at
        - updated_at
      title: Organisation
    TransactionBasic:
      type: object
      properties:
        id:
          type: string
        external_id:
          type: string
        profile_id:
          type: string
        meta:
          type: string
        total:
          type: string
        total_original:
          type: string
        rounding:
          type: string
        margin:
          type: string
        is_void:
          type: string
        transacted_at:
          type: string
        timezone:
          type: string
        payments:
          type: string
        receipt_is_email:
          type: string
        receipt_ref:
          type: string
        linked_receipt_ref:
          type: string
        claimed_at:
          type: string
        receipt_email:
          type: string
        currency_id:
          type: string
        currency_rate:
          type: string
        currency:
          type: string
        type:
          type: string
        status:
          type: string
        order_number:
          type: string
        order_id:
          type: string
        external_order_id:
          type: string
        created_at:
          type: string
        updated_at:
          type: string
      required:
        - id
        - external_id
        - profile_id
        - meta
        - total
        - total_original
        - rounding
        - margin
        - is_void
        - transacted_at
        - timezone
        - payments
        - receipt_is_email
        - receipt_ref
        - linked_receipt_ref
        - claimed_at
        - receipt_email
        - currency_id
        - currency_rate
        - currency
        - type
        - status
        - order_number
        - order_id
        - external_order_id
        - created_at
        - updated_at
      title: TransactionBasic
    ProductOption:
      type: object
      properties:
        name:
          type: string
        value:
          type: string
        sort_order:
          type:
            - integer
            - 'null'
      required:
        - name
        - value
        - sort_order
      title: ProductOption
    Location:
      type: object
      properties:
        id:
          type: integer
        type:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        handle:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        phone:
          type:
            - string
            - 'null'
        email:
          type:
            - string
            - 'null'
        timezone:
          type:
            - string
            - 'null'
        external_id:
          type:
            - string
            - 'null'
        external_code:
          type:
            - string
            - 'null'
        is_published:
          type: boolean
        is_permanently_closed:
          type: boolean
        address:
          $ref: '#/components/schemas/Address'
        normal_hours:
          type: array
          items:
            $ref: '#/components/schemas/LocationHour'
        special_hours:
          type: array
          items:
            $ref: '#/components/schemas/LocationHour'
        tags:
          type: array
          items:
            $ref: '#/components/schemas/Tag'
        custom_fields:
          type: object
          additionalProperties: {}
        icon:
          type:
            - string
            - 'null'
        country_iso_3:
          type:
            - string
            - 'null'
        image_url:
          type:
            - string
            - 'null'
        created_at:
          type: string
        updated_at:
          type: string
        departments:
          type: array
          items:
            $ref: '#/components/schemas/Department'
      required:
        - id
        - type
        - name
        - handle
        - description
        - phone
        - email
        - timezone
        - external_id
        - external_code
        - is_published
        - is_permanently_closed
        - address
        - normal_hours
        - special_hours
        - tags
        - custom_fields
        - icon
        - country_iso_3
        - image_url
        - created_at
        - updated_at
        - departments
      title: Location
    Address:
      type: object
      properties:
        id:
          type: integer
        address_line_1:
          type: string
        address_line_2:
          type:
            - string
            - 'null'
        address_line_3:
          type:
            - string
            - 'null'
        company:
          type:
            - string
            - 'null'
        latitude:
          type:
            - number
            - 'null'
        longitude:
          type:
            - number
            - 'null'
        city:
          type: string
        postcode:
          type: string
        state:
          type:
            - string
            - 'null'
        country:
          type: string
        notes:
          type:
            - string
            - 'null'
        external_id:
          type:
            - string
            - 'null'
        is_default:
          type: boolean
        created_at:
          type: string
        updated_at:
          type: string
        meta:
          type:
            - array
            - 'null'
          items: {}
        name:
          type:
            - string
            - 'null'
        type:
          type:
            - string
            - 'null'
        phone:
          type:
            - string
            - 'null'
        iso:
          type:
            - string
            - 'null'
        iso_state:
          type:
            - string
            - 'null'
        profile_id:
          type:
            - string
            - 'null'
        custom_fields:
          type: object
          additionalProperties: {}
      required:
        - id
        - address_line_1
        - address_line_2
        - address_line_3
        - company
        - latitude
        - longitude
        - city
        - postcode
        - state
        - country
        - notes
        - external_id
        - is_default
        - created_at
        - updated_at
        - meta
        - name
        - type
        - phone
        - iso
        - iso_state
        - profile_id
        - custom_fields
      title: Address
    LocationHour:
      type: array
      items: {}
      title: LocationHour
    Department:
      type: object
      properties:
        id:
          type: integer
        name:
          type:
            - string
            - 'null'
        handle:
          type: string
        external_id:
          type:
            - string
            - 'null'
        external_code:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        short_description:
          type:
            - string
            - 'null'
        url:
          type:
            - string
            - 'null'
        image_url:
          type:
            - string
            - 'null'
        internal_note:
          type:
            - string
            - 'null'
        meta:
          type:
            - array
            - 'null'
          items: {}
        brand_id:
          type: integer
        location_id:
          type:
            - integer
            - 'null'
        brand:
          type: object
          properties:
            name:
              type: string
            handle:
              type: string
          required:
            - name
            - handle
        created_at:
          type: string
        updated_at:
          type: string
      required:
        - id
        - name
        - handle
        - external_id
        - external_code
        - description
        - short_description
        - url
        - image_url
        - internal_note
        - meta
        - brand_id
        - location_id
        - brand
        - created_at
        - updated_at
      title: Department
  responses:
    AuthenticationException:
      description: Unauthenticated
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    AuthorizationException:
      description: Authorization error
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    ModelNotFoundException:
      description: Not found
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    ValidationException:
      description: Validation error
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Errors overview.
              errors:
                type: object
                description: A detailed description of each field that failed validation.
                additionalProperties:
                  type: array
                  items:
                    type: string
            required:
              - message
              - errors

````